use 5.008_007;
use ExtUtils::MakeMaker;
use strict;
use warnings;
use Config;
use Getopt::Long 'GetOptions';

GetOptions(
  'meta' => \my $meta,
  'no-build-spvm-modules' => \my $no_build_spvm_modules,
);

if ($meta) {
  $no_build_spvm_modules = 1;
}

unless ($meta) {
  # Do something such as environment check
}

my %spvm_requires = ('SPVM' => '0.9670');
WriteMakefile(
  NAME              => 'SPVM::Regex',
  VERSION_FROM      => 'lib/SPVM/Regex.pm',
  LICENSE           => 'perl_5',
  ($] >= 5.005 ?     ## Add these new keywords supported since 5.005
    (ABSTRACT_FROM  => 'lib/SPVM/Regex.pm',
     AUTHOR         => 'Yuki Kimoto<kimoto.yuki@gmail.com>') : ()),
  test => {TESTS => 't/*.t'},
  clean => {FILES => ['.spvm_build', 't/.spvm_build']},
  META_MERGE => {
    'meta-spec' => { version => 2 },
    resources => {
      repository => {
        type => 'git',
        url  => 'https://github.com/yuki-kimoto/SPVM-Regex.git',
        web  => 'https://github.com/yuki-kimoto/SPVM-Regex',
      },
    },
  },
  NORECURS => 1,
  CONFIGURE_REQUIRES => {
    %spvm_requires,
  },
  PREREQ_PM         => {
    %spvm_requires,
    'SPVM::Unicode' => '0.03',
    'SPVM::Resource::Re2::V2022_06_01' => '0.06',
  },
  TEST_REQUIRES => {
  },
);

sub MY::postamble {

  my $make_rule = '';

  unless ($no_build_spvm_modules) {
    require SPVM::Builder::Util::API;
    $make_rule .= SPVM::Builder::Util::API::create_make_rule_native('Regex');
    $make_rule .= SPVM::Builder::Util::API::create_make_rule_precompile('Regex');
  }
  
  return $make_rule;
}

1;
